PROGRAM PERIOD(ENTREEC,INPUT,OUTPUT);
LABEL 888;
CONST RAPPORT=2;    (* SIZE OF A REAL N./ SIZE OF AN INTEGER  *)
                    (* MACINTOSH UCSDP: 4 ; IBM: 2 ; CYBER: 1 *)
      LIMITE=15000; (* maximum n. of values in a series                   *)
      LIMIT2=30000; (* LIMITE X RAPPORT --change this value accordingly-- *)
      LIMCLASSES=60;(* maximum n. of classes in a nominal variable        *)
      LN2=0.69314718056;
      FACTEUR=40.0;
      LANG=1;       (* Parametre de langue: 1=FRANCAIS
                       Language parameter : 2=ENGLISH  *)
TYPE DATA=ARRAY[1..LIMITE]OF REAL;
     DATA1=ARRAY[1..LIMITE]OF INTEGER;
     DATA2=RECORD CASE BOOLEAN OF
          TRUE: (INT: DATA1);
          FALSE: (RE: DATA);
          END;
     RANG=ARRAY[0..LIMCLASSES] OF INTEGER;
     RANG1=ARRAY[0..LIMCLASSES] OF REAL;
     RANG2=RECORD CASE BOOLEAN OF
            TRUE: (INTE: RANG);
            FALSE: (REE: RANG1);
            END;
VAR I,J,K,L,NOBS,PTR,PTRI,PTRTEMP,NBCLASSES,NBVAR,CHOIX,CLASFIX:
            INTEGER;
ENTROPIE,ANCIENENTROPIE,SUMRANK,NOUVEAUSUMRANK,MAXRANK,TEMPSUMRANK:REAL;
    DELTA,TEMPRANK: REAL;
    ERREUR,CLASSE,VARIANCE: BOOLEAN;
    CAR: CHAR;
    MATPTR: RANG;
    MATRANK: ARRAY[0..LIMCLASSES]OF REAL;
    MATENTROPIE: RANG2;
    DONNEES: DATA2;
    MATCAR: PACKED ARRAY[0..40]OF CHAR;
    MATCHI: ARRAY[1..38,1..4]OF REAL;
(*  ENTREEC: FILE OF CHAR;       FOR CONTROL DATA OR MACINTOSH *)
    ENTREEC: TEXT;                (*     FOR IBM MACHINES      *)
    TEMP,TEMP1: FILE OF REAL;
 
PROCEDURE INIT;
VAR I: INTEGER;
BEGIN                           (* WHAT FOLLOWS IS A CHI SQUARE TABLE *)
FOR I:=1 TO 40 DO MATCAR[I]:=' ';
MATCAR[0]:='.';MATCAR[10]:='.';MATCAR[20]:='.';MATCAR[30]:='.';
                                               MATCAR[40]:='.';
MATCHI[1,1]:=7.88;MATCHI[1,2]:=6.63;MATCHI[1,3]:=3.84;MATCHI[1,4]:=2.71;
MATCHI[2,1]:=10.6;MATCHI[2,2]:=9.21;MATCHI[2,3]:=5.99;MATCHI[2,4]:=4.61;
MATCHI[3,1]:=12.8;MATCHI[3,2]:=11.3;MATCHI[3,3]:=7.81;MATCHI[3,4]:=6.25;
MATCHI[4,1]:=14.9;MATCHI[4,2]:=13.3;MATCHI[4,3]:=9.49;MATCHI[4,4]:=7.78;
MATCHI[5,1]:=16.7;MATCHI[5,2]:=15.1;MATCHI[5,3]:=11.1;MATCHI[5,4]:=9.24;
MATCHI[6,1]:=18.5;MATCHI[6,2]:=16.8;MATCHI[6,3]:=12.6;MATCHI[6,4]:=10.6;
MATCHI[7,1]:=20.3;MATCHI[7,2]:=18.5;MATCHI[7,3]:=14.1;MATCHI[7,4]:=12.0;
MATCHI[8,1]:=22.0;MATCHI[8,2]:=20.1;MATCHI[8,3]:=15.5;MATCHI[8,4]:=13.4;
MATCHI[9,1]:=23.6;MATCHI[9,2]:=21.7;MATCHI[9,3]:=16.9;MATCHI[9,4]:=14.7;
MATCHI[10,1]:=25.2;MATCHI[10,2]:=23.2;MATCHI[10,3]:=18.3;
                                      MATCHI[10,4]:=16.0;
MATCHI[11,1]:=26.8;MATCHI[11,2]:=24.7;MATCHI[11,3]:=19.7;
                                      MATCHI[11,4]:=17.3;
MATCHI[12,1]:=28.3;MATCHI[12,2]:=26.2;MATCHI[12,3]:=21.0;
                                      MATCHI[12,4]:=18.5;
MATCHI[13,1]:=29.8;MATCHI[13,2]:=27.7;MATCHI[13,3]:=22.4;
                                      MATCHI[13,4]:=19.8;
MATCHI[14,1]:=31.3;MATCHI[14,2]:=29.1;MATCHI[14,3]:=23.7;
                                      MATCHI[14,4]:=21.1;
MATCHI[15,1]:=32.8;MATCHI[15,2]:=30.6;MATCHI[15,3]:=25.0;
                                      MATCHI[15,4]:=22.3;
MATCHI[16,1]:=34.3;MATCHI[16,2]:=32.0;MATCHI[16,3]:=26.3;
                                      MATCHI[16,4]:=23.5;
MATCHI[17,1]:=35.7;MATCHI[17,2]:=33.4;MATCHI[17,3]:=27.6;
                                      MATCHI[17,4]:=24.8;
MATCHI[18,1]:=37.2;MATCHI[18,2]:=34.8;MATCHI[18,3]:=28.9;
                                      MATCHI[18,4]:=26.0;
MATCHI[19,1]:=38.6;MATCHI[19,2]:=36.2;MATCHI[19,3]:=30.1;
                                      MATCHI[19,4]:=27.2;
MATCHI[20,1]:=40.0;MATCHI[20,2]:=37.6;MATCHI[20,3]:=31.4;
                                      MATCHI[20,4]:=28.4;
MATCHI[21,1]:=41.4;MATCHI[21,2]:=38.9;MATCHI[21,3]:=32.7;
                                      MATCHI[21,4]:=29.6;
MATCHI[22,1]:=42.8;MATCHI[22,2]:=40.3;MATCHI[22,3]:=33.9;
                                      MATCHI[22,4]:=30.8;
MATCHI[23,1]:=44.2;MATCHI[23,2]:=41.6;MATCHI[23,3]:=35.2;
                                      MATCHI[23,4]:=32.0;
MATCHI[24,1]:=45.6;MATCHI[24,2]:=43.0;MATCHI[24,3]:=36.4;
                                      MATCHI[24,4]:=33.2;
MATCHI[25,1]:=46.9;MATCHI[25,2]:=44.3;MATCHI[25,3]:=37.7;
                                      MATCHI[25,4]:=34.4;
MATCHI[26,1]:=48.3;MATCHI[26,2]:=45.6;MATCHI[26,3]:=38.9;
                                      MATCHI[26,4]:=35.6;
MATCHI[27,1]:=49.6;MATCHI[27,2]:=47.0;MATCHI[27,3]:=40.1;
                                      MATCHI[27,4]:=36.7;
MATCHI[28,1]:=51.0;MATCHI[28,2]:=48.3;MATCHI[28,3]:=41.3;
                                      MATCHI[28,4]:=37.9;
MATCHI[29,1]:=52.3;MATCHI[29,2]:=49.6;MATCHI[29,3]:=42.6;
                                      MATCHI[29,4]:=39.1;
MATCHI[30,1]:=53.7;MATCHI[30,2]:=50.9;MATCHI[30,3]:=43.8;
                                      MATCHI[30,4]:=40.3;
MATCHI[31,4]:=1.2899833611;
MATCHI[31,3]:=1.645;
MATCHI[31,2]:=2.326666666667;
MATCHI[31,1]:=3.1;
END;
 
PROCEDURE SHELL(VAR A: DATA;N: INTEGER);
LABEL 2;
VAR I,J,K,L,M,O: INTEGER;
    W: REAL;
BEGIN
M:=((2*N)-1) DIV 2;
WHILE M<>0 DO
       BEGIN
      K:=N-M;
      FOR J:=1 TO K DO
            BEGIN
            I:=J;
            WHILE I>=1 DO
                  BEGIN
                  IF A[I+M]>=A[I] THEN GOTO 2;
                  O:=I+M;
                  W:=A[I];A[I]:=A[O];A[O]:=W;
                  I:=I-M;
                   END;
2:           END;
      M:=M DIV 2;
       END;
END;          (* END OF PROCEDURE SHELL *)
 
PROCEDURE LISENTIER;
VAR I: INTEGER;
    STOP: BOOLEAN;                                   (* ADDITION P.L. *)
BEGIN
STOP:=FALSE;                                         (* ADDITION P.L. *)
FOR I:=1 TO NOBS DO
      BEGIN
      READ(ENTREEC,DONNEES.INT[I]);
(* INSTRUCTION REMOVED AT STONY BROOK BECAUSE OF ERROR AMPX033E:      *)
      WHILE ((ENTREEC@=' ')AND(NOT(EOF(ENTREEC)))) DO GET(ENTREEC);
(*    WHILE NOT(STOP) DO
            BEGIN
            IF EOF(ENTREEC) THEN STOP:=TRUE;
            IF (NOT(STOP)) THEN
                   IF (ENTREEC@=' ') THEN GET (ENTREEC)
                   ELSE STOP:=TRUE;
            END;                                                      *)
      IF ((DONNEES.INT[I]<0)OR(DONNEES.INT[I]>60)) THEN
            BEGIN
IF LANG=1 THEN WRITELN(' CODE NON VALIDE DANS LE FICHIER: ',I: 4)
          ELSE WRITELN(' INVALID DESCRIPTOR STATE CODE: ',I: 4);
            GOTO 888;
            END;
      END;
END;
 
FUNCTION LISREEL: REAL;
VAR NB,MUL: REAL;
    I,J,K,L,NBINT,MULT,SIGNE: INTEGER;
    CAR: CHAR;
    MATCAR: ARRAY[1..20]OF CHAR;
    STOP: BOOLEAN;                      (* ADDITION P.L. *)
BEGIN
STOP:=FALSE;                            (* ADDITION P.L. *)
SIGNE:=1;
NB:=0;
NBINT:=0;
MULT:=1;
J:=2;
WHILE NOT(ENTREEC@ IN['.','0'..'9']) DO
      BEGIN
      IF ENTREEC@='-' THEN SIGNE:=-1;
      GET(ENTREEC);
      END;
IF ENTREEC@<>'.' THEN
      BEGIN
      READ(ENTREEC,MATCAR[1]);
      WHILE ENTREEC@ IN['0'..'9']DO
            BEGIN
            READ(ENTREEC,MATCAR[J]);
            J:=J+1;
             END;
      FOR I:=J-1 DOWNTO 1 DO
            BEGIN
            NBINT:=NBINT+(ORD(MATCAR[I])-ORD('0'))*MULT;
            MULT:=MULT*10;
            END;
      NBINT:=NBINT*SIGNE;
      END;
IF ENTREEC@='.' THEN
      BEGIN
      GET(ENTREEC);
      L:=1;
      MUL:=10;
      WHILE (ENTREEC@ IN['0'..'9']) DO
            BEGIN
            READ(ENTREEC,CAR);
            NB:=NB+(ORD(CAR)-ORD('0'))/MUL;
            MUL:=MUL*10;
            END;
      END;
(* INSTRUCTION REMOVED BECAUSE OF ERREUR IBM AMPX033E AT EXECUTION:
WHILE ((NOT(ENTREEC@ IN['.','0'..'9','-']))AND(NOT(EOF(ENTREEC)))) DO
                                        GET (ENTREEC);                *)
WHILE NOT(STOP) DO
      BEGIN
      IF EOF(ENTREEC) THEN STOP:=TRUE;
      IF (NOT(STOP)) THEN
           IF (NOT(ENTREEC@ IN (.'.','0'..'9','-'.))) THEN GET (ENTREEC)
           ELSE STOP:=TRUE;
      END;                                     (* END OF MODIFICATION *)
LISREEL:=NBINT+NB*SIGNE;
END;       (* LISREEL *)
 
PROCEDURE LECTURE;
VAR I,COMPTEUR: INTEGER;
    X: REAL;
BEGIN
COMPTEUR:=0;
REWRITE(TEMP);
FOR I:=1 TO NOBS DO
      BEGIN
      X:=LISREEL;
      DONNEES.RE[I]:=X;
      TEMP@:=X;PUT(TEMP);
      END;
END;
 
 
PROCEDURE CONTINGENCE(VAR MATPTR: RANG;VAR MATENTROPIE: RANG1);
      (* THE CONTINGENCY TABLE IS BUILT.                       *)
      (* REF: LEGENDRE, L., M. FRECHETTE & P. LEGENDRE. 1981.  *)
      (* THE CONTINGENCY PERIODOGRAM: A METHOD OF IDENTIFYING  *)
      (* RHYTHMS IN SERIES OF NONMETRIC ECOLOGICAL DATA.       *)
      (* JOURNAL OF ECOLOGY 69: 965-979.                       *)
VAR I,J,K,NBCASPOSS,NOBS2,NOBS3: INTEGER;
    X,Y,ENTROPIEGAUCHE,ENTROPIEDROITE: REAL;
    FINI: BOOLEAN;
 
      PROCEDURE APPROX;
      VAR I,J:INTEGER;
      BEGIN
      DELTA:=0;MAXRANK:=0;PTRI:=1;K:=1;
      FOR I:=1 TO NBCLASSES DO
             BEGIN
                      (* COMPUTING MAX OF SUMS OF (SUMRANK CARRES/NI) *)
            SUMRANK:=0;
            FOR J:=MATPTR[I-1]+1 TO MATPTR[I]-1 DO
                 BEGIN
                  SUMRANK:=SUMRANK+DONNEES.RE[J];
                  IF DONNEES.RE[J]<>DONNEES.RE[J+1] THEN
                        BEGIN
                        TEMPSUMRANK:=SQR(SUMRANK)/(J-MATPTR[I-1])
                               +SQR(MATRANK[I]-SUMRANK)/(MATPTR[I]-J);
          IF TEMPSUMRANK-SQR(MATRANK[I])/(MATPTR[I]- MATPTR[I-1])
  >MAXRANK-SQR(MATRANK[PTRI])/(MATPTR[PTRI]-MATPTR[PTRI-1]) THEN
                              BEGIN        (* STOPPING CRITERION NO 1 *)
                              PTR:=J;
                              MAXRANK:=TEMPSUMRANK;
                              NOUVEAUSUMRANK:=SUMRANK;
                              PTRI:=I;
                              END;
                        END;
                  END;
            END;
      ANCIENENTROPIE:=ENTROPIE;
      ENTROPIEGAUCHE:=(PTR-MATPTR[PTRI-1])/NOBS;
      ENTROPIEGAUCHE:=-(ENTROPIEGAUCHE*LN(ENTROPIEGAUCHE));
      ENTROPIEDROITE:=(MATPTR[PTRI]-PTR)/NOBS;
      ENTROPIEDROITE:=-(ENTROPIEDROITE*LN(ENTROPIEDROITE));
     ENTROPIE:=ENTROPIE-MATENTROPIE[PTRI]+ENTROPIEGAUCHE+ENTROPIEDROITE;
      IF (ENTROPIE/(NBCLASSES+1)<ANCIENENTROPIE/NBCLASSES)
         AND(CLASFIX<=0)THEN FINI:=TRUE    (* STOPPING CRITERION NO 2 *)
      ELSE
            BEGIN
            FOR I:=NBCLASSES DOWNTO PTRI DO
                  BEGIN
                  MATPTR[I+1]:=MATPTR[I];
                  MATRANK[I+1]:=MATRANK[I];
                  MATENTROPIE[I+1]:=MATENTROPIE[I];
                  END;
            MATPTR[PTRI]:=PTR;
            MATRANK[PTRI]:=NOUVEAUSUMRANK;
            MATRANK[PTRI+1]:=MATRANK[PTRI+1]-NOUVEAUSUMRANK;
            MATENTROPIE[PTRI]:=ENTROPIEGAUCHE;
            MATENTROPIE[PTRI+1]:=ENTROPIEDROITE;
            NBCLASSES:=NBCLASSES+1;
            END;
      END;     (* END OF PROCEDURE APPROX *)
 
      PROCEDURE EXACT(VAR DONNEE:DATA);
      VAR I,J,L,N,M,NBCL2,NBCL3:INTEGER;
          MAX,X:REAL;
          MAT:RANG;
      BEGIN
      PTRTEMP:=0;
      ANCIENENTROPIE:=ENTROPIE;
      NBCL2:=(3*RAPPORT+NBCLASSES-1)*NOBS;
      NBCL3:=NBCL2+NOBS;
      FOR I:=NOBS+1 TO 2*NOBS DO DONNEE[I]:=DONNEES.RE[I+NOBS];
      FOR I:=NBCL2+1 TO NBCL3 DO DONNEES.INT[I]:=0;
      FOR I:=NOBS2+1 TO NOBS2+NOBS DO DONNEE[I]:=0;
    FOR M:=1 TO NOBS DO IF((DONNEE[M]<>DONNEES.RE[M+1])OR(M=NOBS)) THEN
            BEGIN
            MAX:=0;
            FOR N:=1 TO M DO IF ((DONNEE[N]<>DONNEES.RE[N+1])OR(M=NOBS))
            THEN  BEGIN
                  X:=0;
                  IF N < M THEN
                        BEGIN
                        FOR L:=N+1 TO M DO X:=X+DONNEE[L];
                        X:=SQR(X)/(M-N)+DONNEE[NOBS+N];
                        END;
                  IF X>MAX THEN
                        BEGIN
                        MAX:=X;
                        PTRTEMP:=N;
                        END;
                  END;
            DONNEE[NOBS2+M]:=MAX;
            DONNEES.INT[NBCL2+M]:=PTRTEMP;
            END;
      (* ******ENTROPY ****** *)
      NBCLASSES:=NBCLASSES+1;
      PTRTEMP:=NOBS;
      MAT[NBCLASSES]:=NOBS;
      FOR I:=NBCLASSES-1 DOWNTO 1 DO
            BEGIN
            N:=NBCL2+PTRTEMP;
            PTRTEMP:=DONNEES.INT[N];
            MAT[I]:=PTRTEMP;
            NBCL2:=NBCL2-NOBS;
            END;
      ENTROPIE:=0;
      MAT[0]:=0;
      FOR I:=NBCLASSES DOWNTO 1 DO
            BEGIN
            N:=MAT[I]-MAT[I-1];
            X:=N/NOBS;X:=X*LN(X);
            ENTROPIE:=ENTROPIE-X;
            MATENTROPIE[I]:=-X;
            END;
IF ((ENTROPIE/NBCLASSES<ANCIENENTROPIE/(NBCLASSES-1))AND(CLASFIX<=0))
       THEN BEGIN                          (* STOPPING CRITERION NO 2 *)
            FINI:=TRUE;
            NBCLASSES:=NBCLASSES-1;
            END
       ELSE FOR I:=1 TO NBCLASSES DO
            BEGIN
            N:=MAT[I];
            MATPTR[I]:=N;
            MAX:=0;
            FOR J:=MAT[I-1]+1 TO N DO MAX:=MAX+DONNEE[I];
            MATRANK[I]:=MAX;
            END;
      END;  (* END OF PROCEDURE EXACT *)
 
BEGIN
NOBS2:=2*NOBS;NOBS3:=NOBS2+NOBS;
MATRANK[0]:=0;
MATPTR[0]:=0;
MATPTR[1]:=NOBS;
MATPTR[2]:=0;
ENTROPIE:=0;
WITH DONNEES DO
      BEGIN
      IF NOT VARIANCE THEN
            BEGIN
            REWRITE(TEMP1);
            Y:=1;
            FOR I:=2 TO NOBS DO
                  BEGIN
                  X:=RE[I-1];
                  TEMP1@:=X;PUT(TEMP1);
                  RE[I-1]:=Y;
                  IF RE[I]<>X THEN Y:=Y+1.0;
                  END;
            TEMP1@:=RE[NOBS];PUT(TEMP1);
            RE[NOBS]:=Y;
            NBCASPOSS:=ROUND(Y);
            END
      ELSE
            BEGIN
            NBCASPOSS:=1;
            FOR I:=2 TO NOBS DO
               IF RE[I]<>RE[I-1] THEN NBCASPOSS:=NBCASPOSS+1;
            END;
      X:=0;
      FOR I:=1 TO NOBS DO X:=X+RE[I];
      MATRANK[1]:=X;
      MATENTROPIE[1]:=0;
      NBCLASSES:=1;
      FINI:=FALSE;
      WRITELN;WRITELN;
      IF LANG=1 THEN WRITELN(' TABLEAU DE CONTINGENCE: ')
                ELSE WRITELN(' CONTINGENCY TABLE: ');
      WRITELN;
      X:=0;
      IF NOBS*4 < LIMITE THEN
            BEGIN
            FOR I:=1 TO NOBS DO
                  BEGIN
                  X:=X+RE[I];
                  IF RE[I]=RE[I+1] THEN RE[NOBS2+I]:=0
                  ELSE  RE[I+NOBS2]:=SQR(X)/I;
                  END;
            RE[NOBS3]:=SQR(X)/NOBS;
            END;
      INT[NOBS3+1]:=0;
      REPEAT
      IF ((NBCLASSES=LIMCLASSES) OR((NBCLASSES=1)AND(NBCASPOSS=1))) THEN
            BEGIN
              IF LANG=1 THEN BEGIN
              WRITELN(' IL Y A TROP DE CLASSES DANS VOS DONNEES ');
              WRITELN(' (plus que "LIMCLASSES"). RECODEZ VOS DONNEES.');
              END ELSE BEGIN
              WRITELN(' TOO MANY CHARACTER STATES IN THE DATA ');
              WRITELN(' (more than "LIMCLASSES"). RECODE YOUR DATA.');
              END;
            GOTO 888;
            END;
      IF (3*NOBS*RAPPORT+NBCLASSES+1)*NOBS<LIMIT2 THEN EXACT(RE)
      ELSE APPROX;
      UNTIL ((FINI)OR(CLASFIX=NBCLASSES))OR(NBCLASSES=NBCASPOSS);
      IF LANG=1 THEN BEGIN
      WRITELN(' NOMBRE DE CLASSES: ',NBCLASSES: 4);
      WRITELN('        CLASSE   BORNE SUPERIEURE ');
               (* LES NOUVEAUX CODES SONT PRETS A ETRE REECRITS.      *)
               (* ON INSCRIT D'ABORD LES VALEURS LIMITES DANS MATRANK *)
      END ELSE BEGIN
      WRITELN(' NUMBER OF CLASSES: ',NBCLASSES: 4);
      WRITELN('        CLASS      UPPER LIMIT ');
               (* THE NEW DESCRIPTOR CODES ARE READY TO BE WRITTEN.   *)
               (* THE LIMIT VALUES ARE FIRST WRITTEN IN MATRANK.      *)
      END; IF NOT VARIANCE THEN
            BEGIN
            RESET(TEMP1);
            FOR I:=1 TO NOBS DO
                  BEGIN
                  RE[I]:=TEMP1@;GET(TEMP1);
                  END;
            END;
      FOR I:=1 TO NBCLASSES DO MATRANK[I]:=RE[MATPTR[I]];
      FOR I:=1 TO NBCLASSES DO WRITELN(I,'      ',MATRANK[I]: 10: 5);
      WRITELN;
      IF CLASFIX=NBCLASSES THEN ANCIENENTROPIE:=ENTROPIE;
IF LANG=1 THEN WRITELN(' H(S)/S : ',ANCIENENTROPIE/(NBCLASSES*LN2):
                                      10: 5,'    EN LOG BASE 2  ')
          ELSE WRITELN(' H(S)/S : ',ANCIENENTROPIE/(NBCLASSES*LN2):
                                      10: 5,'    IN BASE 2 LOGS ');
      RESET(TEMP);
      FOR I:=1 TO NOBS DO
            BEGIN
            X:=TEMP@;GET(TEMP);
            J:=NBCLASSES+1;
            REPEAT J:=J-1 UNTIL X>MATRANK[J];
            DONNEES.INT[I]:=J+1;
            END;
      END
END;       (* END COMPUTING THE CONTINGENCY TABLE *)
 
 
FUNCTION GAUSS(X: REAL): REAL;
VAR Y,Z,W: REAL;
BEGIN
                              (* REFERENCE:  CACM                 *)
                              (* ALGORITHM:  209                  *)
                              (* AUTHOR: D. IBBETSON              *)
                              (* TITLE: GAUSS                     *)
                              (* TRANSLATED TO PASCAL BY A.VAUDOR *)
IF X=0 THEN Z:=0
ELSE
      BEGIN
      Y:=ABS(X)/2;
      IF Y>=3 THEN Z:=1
      ELSE IF Y<1 THEN
            BEGIN
            W:=Y*Y;
            Z:=((((((((0.000124818987*W
            -0.001075204047)*W+0.005198775019)*W
            -0.019198292004)*W+0.059054035642)*W
            -0.151968751364)*W+0.319152932694)*W
            -0.531923007300)*W+0.797884560593)*Y*2
            END
          ELSE
            BEGIN
            Y:=Y-2;
            Z:=(((((((((((((-0.000045255659*Y
            +0.000152529290)*Y-0.000019538132)*Y
            -0.000676904986)*Y+0.001390604284)*Y
            -0.000794620820)*Y-0.002034254874)*Y
            +0.006549791214)*Y-0.010557625006)*Y
            +0.011630447319)*Y-0.009279453341)*Y
            +0.005353579108)*Y-0.002141268741)*Y
            +0.000535310849)*Y+0.999936657524
            END
      END;
IF X>0 THEN GAUSS:=(Z+1)/2 ELSE GAUSS:=(1-Z)/2;
END;      (* GAUSS *)
 
FUNCTION CHIPROB(X: REAL;F: INTEGER;BIGX: BOOLEAN;VAR WRONG: BOOLEAN):
                                                                 REAL;
VAR A,Y,S,E,C,Z: REAL;
    EVEN: BOOLEAN;
BEGIN
IF ((X<0)OR (F<1)) THEN WRONG:=TRUE
ELSE
   IF X=0 THEN CHIPROB:=1
   ELSE
      BEGIN
      A:=0.5*X;EVEN:=2*(F DIV 2)=F;
      IF ((EVEN) OR((F>2) AND (NOT BIGX))) THEN Y:=EXP(-A);
      IF EVEN THEN S:=Y ELSE S:=2*(GAUSS(-SQRT(X)));
      IF F>2 THEN
            BEGIN
            X:=0.5*(F-1);
            IF EVEN THEN Z:=1 ELSE Z:=0.5;
            IF BIGX THEN
                  BEGIN
                  IF EVEN THEN E:=0 ELSE E:=0.572364842925;
                  C:=LN(A);
                  WHILE Z<X DO
                        BEGIN
                        E:=LN(Z)+E;
                        S:=EXP(C*Z-A-E)+S;
                        Z:=Z+1;
                        END;
                  CHIPROB:=S;
                  END
            ELSE
                  BEGIN
                  IF EVEN THEN E:=1 ELSE E:=0.564189583548/SQRT(A);
                  C:=0;
                  WHILE Z<X DO
                        BEGIN
                        E:=E*A/Z;
                        C:=C+E;
                        Z:=Z+1;
                        END;
                  CHIPROB:=C*Y+S;
                  END
            END
      ELSE CHIPROB:=S;
      END;
END;      (* CHIPROB *)
 
PROCEDURE CALCUL(VAR DONNEES: DATA1;VAR MARGLIGNE,MARGCASE: RANG);
VAR I,J,K,L,NOBS2,MARGCOL,NBETATS,TOTAL,NOCASE,J1,LIBERTE,POSITIONP,
                                                POSITIONPROB: INTEGER;
    ERREUR: BOOLEAN;
    X,LNMARGCOL,LNMARGLIGNE,LNCARDCASE,ENTROPIE,PROB,P,PROBP: REAL;
 
PROCEDURE CALCULLIGNE(VAR MARGLIGNE: RANG;VAR TOTAL,NBETATS: INTEGER;
                                                VAR LNMARGLIGNE: REAL);
VAR I,JJ: INTEGER;
BEGIN
        (* CALCUL DES MARGINAUX LIGNES ET LEUR ENTROPIE *)
LNMARGLIGNE:=0;TOTAL:=0;NBETATS:=0;
FOR I:=1 TO LIMCLASSES DO MARGLIGNE[I]:=0;
FOR I:=1 TO NOBS DO
      BEGIN
      JJ:=DONNEES[I];
      IF JJ>NBETATS THEN NBETATS:=JJ;
      MARGLIGNE[JJ]:=MARGLIGNE[JJ]+1;
      TOTAL:=TOTAL+1;
      END;
FOR I:=1 TO NBETATS DO IF MARGLIGNE[I]<>0 THEN
      BEGIN
      X:=MARGLIGNE[I]/TOTAL;
      LNMARGLIGNE:=LNMARGLIGNE-(X*LN(X));
      END;
END;       (* END COMPUTING LINE MARGINALS *)
 
BEGIN      (* BEGIN PROCEDURE CALCUL *)
CALCULLIGNE(MARGCASE,TOTAL,NBETATS,LNMARGLIGNE);
NOBS2:=NOBS DIV 2;
INIT;
WRITELN;
IF LANG=1 THEN BEGIN WRITELN(
'             P E R I O D O G R A M M E   D E   C O N T I N G E N C E');
WRITELN;WRITELN;
WRITE('      (+=INTERVALLE DE CONFIANCE, *==>(+=B) )');
WRITELN('       L''ECHELLE DE B EST EN LOG. NAT.');
END ELSE BEGIN
WRITELN('             C O N T I N G E N C Y   P E R I O D O G R A M ');
WRITELN;WRITELN;
WRITE('      (+=CONFIDENCE INTERVAL, *==>(+=B) )');
WRITELN('       THE SCALE OF B IS IN NATURAL LOG ');
END; WRITELN;
WRITE('  T=_ 0',LNMARGLIGNE/4:10:2,LNMARGLIGNE/2:10:2,LNMARGLIGNE*0.75:
                                                                 10:2);
IF LANG=1 THEN WRITELN(LNMARGLIGNE:10:2,' ':12,' VALEUR ')
          ELSE WRITELN(LNMARGLIGNE:10:2,' ':12,'CRITICAL');
WRITE(' ': 5);
FOR I:=0 TO 40 DO WRITE(MATCAR[I]);
IF LANG=1 THEN WRITELN('      B      CRITIQUE  PROB(2NB)')
          ELSE WRITELN('      B       VALUE    PROB(2NB)');
FOR I:=2 TO NOBS2 DO
      BEGIN
      LNMARGCOL:=0;LNCARDCASE:=0;
      LIBERTE:=(NBETATS-1)*(I-1);
      FOR J:=1 TO I DO
            BEGIN
            MARGCOL:=0;J1:=J;
            FOR K:=1 TO NBETATS DO MARGCASE[K]:=0;
            WHILE J1<=NOBS DO
                   BEGIN
                   MARGCOL:=MARGCOL+1;
                   NOCASE:=DONNEES[J1];
                   MARGCASE[NOCASE]:=MARGCASE[NOCASE]+1;
                   J1:=J1+I;
                   END;
             FOR K:=1 TO NBETATS DO IF MARGCASE[K]<>0 THEN
                  BEGIN
                  X:=MARGCASE[K]/TOTAL;
                  LNCARDCASE:=LNCARDCASE-X*LN(X);
                  END;
            LNMARGCOL:=LNMARGCOL-(MARGCOL/TOTAL)*LN(MARGCOL/TOTAL);
            END;
      ENTROPIE:=LNMARGCOL+LNMARGLIGNE-LNCARDCASE;
      ERREUR:=FALSE;
      IF LIBERTE<=30 THEN PROBP:=MATCHI[LIBERTE,CHOIX]
      ELSE PROBP:=SQR(MATCHI[31,CHOIX]+SQRT(2*LIBERTE-1))/2;
      PROBP:=PROBP/(2*NOBS);
      POSITIONPROB:=ROUND(PROBP/LNMARGLIGNE*FACTEUR);
      POSITIONP:=ROUND(ENTROPIE/LNMARGLIGNE*FACTEUR);
      WRITE(I: 5);
      IF POSITIONP<>POSITIONPROB THEN
            BEGIN
            IF POSITIONP <=40 THEN MATCAR[POSITIONP]:='B';
            IF POSITIONPROB <=40 THEN MATCAR[POSITIONPROB]:='+';
            END
      ELSE IF POSITIONP <=40 THEN MATCAR[POSITIONP]:='*';
      FOR J:=0 TO 40 DO WRITE(MATCAR[J]);
      IF POSITIONP <=40 THEN
      BEGIN
      IF POSITIONP MOD 10=0 THEN MATCAR[POSITIONP]:='.'
                            ELSE MATCAR[POSITIONP]:=' ';
      END;
      IF POSITIONPROB<=40 THEN
      BEGIN
      IF POSITIONPROB MOD 10=0 THEN MATCAR [POSITIONPROB]:='.'
                               ELSE MATCAR [POSITIONPROB]:=' ';
      END;
      WRITE(ENTROPIE: 10: 5);
      PROB:=CHIPROB(ENTROPIE*(2*TOTAL),LIBERTE,ENTROPIE>10E10,ERREUR);
      WRITE(PROBP: 10: 5,PROB: 10: 5);
      IF PROB <= 0.1 THEN
            BEGIN
            WRITE(' *');
            IF PROB <= 0.05 THEN
                  BEGIN
                  WRITE('*');
                  IF PROB <= 0.01 THEN
                        BEGIN
                        WRITE('*');
                        IF PROB <=0.001 THEN WRITE('*');
                        END;
                  END;
            END;
      WRITELN;
      IF ERREUR THEN
IF LANG=1 THEN WRITELN(' D.L. TROP FAIBLE: probabilite non valable. ')
          ELSE WRITELN(' NOT ENOUGH D.F.: probability is meaningless.');
      END;
END;
 
BEGIN        (* BEGIN MAIN PROGRAM *)
WRITELN;
IF LANG=1 THEN BEGIN
WRITELN(' P E R I O D O G R A M M E   D E   C O N T I N G E N C E ');
WRITELN;
WRITELN(' VERSION 2.0b');
WRITELN;
WRITELN(' UNIVERSITE DE MONTREAL');
WRITELN(' DEPARTEMENT DE SCIENCES BIOLOGIQUES ');
WRITELN(' CASE POSTALE 6128, SUCC. "A"');
WRITELN(' MONTREAL, P.Q. H3C 3J7');
WRITELN;
WRITELN(' AUTEUR:  A. VAUDOR');
END ELSE BEGIN
WRITELN(' C O N T I N G E N C Y   P E R I O D O G R A M ');
WRITELN;
WRITELN(' VERSION 2.0b ');
WRITELN;
WRITELN(' UNIVERSITE DE MONTREAL');
WRITELN(' DEPARTEMENT DE SCIENCES BIOLOGIQUES ');
WRITELN(' CASE POSTALE 6128, SUCC. "A"');
WRITELN(' MONTREAL, P.Q. H3C 3J7');
WRITELN;
WRITELN(' AUTHOR:  A. VAUDOR');
END; WRITELN;WRITELN;
IF LANG=1 THEN WRITELN(' NOMBRE D''OBSERVATIONS   ')
          ELSE WRITELN(' NUMBER OF OBSERVATIONS   ');
READLN(NOBS);
IF LANG=1 THEN WRITELN(' NOMBRE DE VARIABLES    ')
          ELSE WRITELN(' NUMBER OF VARIABLES    ');
READLN(NBVAR);
IF LANG=1 THEN
WRITELN(' LES DONNEES SONT-ELLES DEJA DIVISEES EN CLASSES? (O ou N) ')
ELSE WRITELN(' ARE THE DATA ALREADY DIVIDED INTO CLASSES ? (Y or N) ');
WHILE NOT(INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
CLASSE:=INPUT@ IN ['0','O','o','Y','y'];READLN;
IF NOT CLASSE THEN BEGIN
WRITELN;
IF LANG=1 THEN BEGIN
WRITELN(' Noter que ce programme emploie la procedure EXACT,  lorsque');
WRITELN(' cela  est possible,  pour diviser une variable  en classes.');
WRITELN(' Ceci peut conduire a une meilleure partition  que la proce-');
WRITELN(' dure pas a pas decrite par Legendre et al. (1981: 969-973),');
WRITELN(' procedure qui porte le nom de APPROX dans ce programme.    ');
END ELSE BEGIN
WRITELN(' Note that this program  uses procedure EXACT,  whenever ');
WRITELN(' possible, to partition a variable into classes.  It may ');
WRITELN(' produce a better partitioning  than the stepwise proce- ');
WRITELN(' dure  described in  Legendre et al. ( 1981:  969-973 ), ');
WRITELN(' called APPROX in the source program.                    ');
END; WRITELN;
      END;
CLASFIX:=LIMCLASSES+1;
IF NOT CLASSE THEN WHILE CLASFIX>LIMCLASSES DO
      BEGIN
IF LANG=1 THEN
WRITELN(' NOMBRE DE CLASSES ? (0 POUR CALCUL PAR LE PROGRAMME) ')
ELSE
WRITELN(' NUMBER OF CLASSES ? (0 IF THE PROGRAM IS TO DECIDE) ');
      READLN(CLASFIX);
      END;
IF NOT CLASSE THEN BEGIN
  IF LANG=1 THEN
  WRITELN(' DESIREZ-VOUS TRANSFORMER LES DONNEES EN RANGS ? ')
  ELSE WRITELN(' DO YOU WANT THE VALUES TRANSFORMED INTO RANKS ? ');
  WHILE NOT(INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
  VARIANCE:=INPUT@ IN ['0','O','o','Y','y'];READLN;
END; CHOIX:=0;
WHILE NOT(CHOIX IN[1..4]) DO
      BEGIN
IF LANG=1 THEN BEGIN
WRITELN(' CHOIX DE L''INTERVALLE DE CONFIANCE: ');
WRITELN(' 1 pour  0.005 , 2 pour  0.01, 3 pour  0.05, 4 pour  0.10');
END ELSE BEGIN
WRITELN(' CHOOSE CONFIDENCE INTERVAL : ');
WRITELN(' TYPE  1 for  0.005 , 2 for  0.01, 3 for  0.05, 4 for  0.10');
END;  READLN(CHOIX);
      END;
RESET(ENTREEC);
FOR I:=1 TO NBVAR DO
      BEGIN
      IF CLASSE THEN LISENTIER
      ELSE
            BEGIN
            LECTURE;
            SHELL(DONNEES.RE,NOBS);
            CONTINGENCE(MATPTR,MATENTROPIE.REE);
            END;
      CALCUL(DONNEES.INT,MATPTR,MATENTROPIE.INTE);
      END;
888:
IF LANG=1 THEN WRITELN(' Fin du programme. ')
               ELSE WRITELN(' End of the program. ');
END.
