PROGRAM REGARDE(ENTREEC,SORTIEC,OUTPUT);
CONST MAXLIGNES=40;
      MAXCOLONNES=7;
      VIDE='          ';
      NBMOTS=1;
      NBCAR=10;          (* NBMOTS X NBCAR=N. CHAR. IN LINE IDENTIFIERS *)
      MAXREEL=1.70E38;   (* MAXIMUM VALUE FOR THIS COMPUTER *)
      ABSENT=1.70E38;    (* EXPOSANT:=EXPOSANT-1 *)
      LANG=1;            (* Parametre de langue: 1=FRANCAIS
                            Language parameter : 2=ENGLISH  *)
TYPE ALFFA=PACKED ARRAY[1..NBCAR] OF CHAR;
     ALFFA1=PACKED ARRAY[1..10] OF CHAR;
     VARIABLE=RECORD CASE INTEGER OF
              1:(INT:INTEGER);
              2:(REE:REAL);
              3:(CAR:ALFFA);
              END;
     LINK=@REC;
     REC=RECORD
         MATID:ARRAY[1..MAXCOLONNES] OF ALFFA1;
         DATA :ARRAY[1..MAXCOLONNES,1..MAXLIGNES] OF REAL;
         LIEN:LINK;
         END;
VAR NOBJ,NBDESC,NBMAT,PTRLIGNES:INTEGER;
    FIRST,PTRLINE:LINK;
    IDENT:ARRAY[1..MAXLIGNES] OF ALFFA1;
    MULT:VARIABLE;
    TITRE:BOOLEAN;
    ENTREEC:FILE OF VARIABLE;
    SORTIEC:TEXT;

PROCEDURE MEMOIRE(VAR FIRST:LINK);
VAR I,J,K:INTEGER;
    P:LINK;
BEGIN
FIRST:=NIL;
FOR I:=0 TO NBMAT DO
      BEGIN
      NEW(P);
      P@.LIEN:=FIRST;
      FIRST:=P;
      END;
PTRLINE:=FIRST;
END;   (* FIN ALLOCATION MEMOIRE *)

PROCEDURE ECRIT(VAR MAT:ALFFA1);
VAR I,J:INTEGER;
BEGIN
J:=0;
FOR I:=1 TO 10 DO
      BEGIN
      J:=J+1;
      MAT[I]:=ENTREEC@.CAR[J];
      IF ((J=NBCAR)OR(I=10)) THEN
            BEGIN
            J:=0;
            GET(ENTREEC);
            END;
      END;
END;   (* FIN ECRIT *)

PROCEDURE ENTETE;
VAR I,J:INTEGER;
    MAT:ALFFA1;
BEGIN
PTRLIGNES:=0;
RESET(ENTREEC);
MULT:=ENTREEC@;
GET(ENTREEC);
NOBJ:=MULT.INT;
MULT:=ENTREEC@;
GET(ENTREEC);
NBDESC:=MULT.INT;
IF LANG=1 THEN WRITE(SORTIEC,' TITRE: ')
          ELSE WRITE(SORTIEC,' TITLE: ');
FOR I:=1 TO 10 DO
      BEGIN
      ECRIT(MAT);
      WRITE(SORTIEC,MAT);
      END;
WRITELN(SORTIEC);
WRITE(SORTIEC,' DATE ');
ECRIT(MAT);
WRITELN(SORTIEC,MAT);
IF LANG=1 THEN WRITE(SORTIEC,' FONCTION ')
          ELSE WRITE(SORTIEC,' FUNCTION ');
ECRIT(MAT);
WRITELN(SORTIEC,MAT);
ECRIT(MAT);
IF MAT <> VIDE THEN WRITE(SORTIEC,MAT);
WRITELN(SORTIEC);
MULT:=ENTREEC@;GET(ENTREEC);
IF LANG=1 THEN BEGIN
WRITELN(SORTIEC,'  NOMBRE D'' OBJETS :',NOBJ:3);
WRITELN(SORTIEC,'  NOMBRE DE DESCRIPTEURS :',NBDESC:3);
END ELSE BEGIN
WRITELN(SORTIEC,'  NUMBER OF OBJECTS :',NOBJ:3);
WRITELN(SORTIEC,'  NUMBER OF DESCRIPTORS :',NBDESC:3);
END;
TITRE:=MULT.INT<>0;
NBMAT:=NOBJ DIV MAXCOLONNES;
END;   (* ENTETE *)

PROCEDURE ENTREID;
VAR I,J,K,L:INTEGER;
    PT:LINK;
BEGIN
J:=0;
PT:=FIRST;
FOR I:=1 TO NOBJ DO
      BEGIN
      J:=J+1;
      ECRIT(PT@.MATID[J]);
      IF J=MAXCOLONNES THEN
            BEGIN
            J:=0;
            PT:=PT@.LIEN;
            END;
      END;
END;   (* FIN ENTREID *)

PROCEDURE COPYTITRE(VAR PTRLIGNES,LIM:INTEGER);
VAR I,J,L:INTEGER;
BEGIN
L:=0;J:=PTRLIGNES MOD MAXCOLONNES;
FOR I:=PTRLIGNES TO LIM DO
      BEGIN
      L:=L+1;
      IDENT[L]:=PTRLINE@.MATID[J];
      J:=J+1;
      IF J>MAXCOLONNES THEN
            BEGIN
            J:=1;
            PTRLINE:=PTRLINE@.LIEN;
            END;
      END;
END;   (* FIN COPYTITRE *)

PROCEDURE ECRITMAT(LIMITE,NBLIGNES,NOMAT,PASSE:INTEGER;PT:REC);
VAR I,J,K,L,COLG,COL,NOLIGNE:INTEGER;
    X:REAL;
BEGIN
NOLIGNE:=PASSE*MAXLIGNES;
COLG:=NOMAT*MAXCOLONNES;
IF NOLIGNE + NBLIGNES > COLG + LIMITE THEN
NBLIGNES:=COLG+LIMITE-NOLIGNE-1;
IF NBLIGNES > 0 THEN
   BEGIN
   WRITELN(SORTIEC);
   WITH PT DO
      BEGIN
      IF TITRE THEN
            BEGIN
            FOR J:=10 DOWNTO 1 DO
                  BEGIN
                  WRITE(SORTIEC,'           ');
                  FOR K:=J-1 DOWNTO 1 DO WRITE(SORTIEC,' ');
                  FOR I:=1 TO LIMITE DO WRITE(SORTIEC,MATID[I,J],'         ');
                  WRITELN(SORTIEC);
                  END;
            END
      ELSE
           BEGIN
           WRITE(SORTIEC,'           ');
           FOR I:=1 TO LIMITE DO WRITE(SORTIEC,COLG + I:10);
           WRITELN(SORTIEC);
           END;
      FOR I:=1 TO NBLIGNES DO
            BEGIN
            NOLIGNE:=NOLIGNE+1;
            WRITE(SORTIEC,' ');
            IF TITRE THEN WRITE(SORTIEC,IDENT[I])
            ELSE WRITE(SORTIEC,NOLIGNE:10);
            FOR J:=1 TO LIMITE DO
                  BEGIN
                  COL:=COLG+J;
                  IF COL > NOLIGNE THEN
                        BEGIN
                        X:=DATA[J,I];
                        IF ABS(X) > ABSENT THEN WRITE(SORTIEC,'    ABSENT')
                        ELSE IF ABS(X) > 999 THEN WRITE(SORTIEC,X:10)
                             ELSE WRITE(SORTIEC,X:10:5);
                        END
                  ELSE WRITE(SORTIEC,VIDE);
                  END;
            WRITELN(SORTIEC);
            END;
      END;
   END;
END;  (* FIN ECRITMAT*)

PROCEDURE ENTREDONNEE;
VAR I,J,JM1,JD1,NBLIGNES,PASSE, II:INTEGER;
    PT:LINK;
BEGIN
NBLIGNES:=0;
PASSE:=0;
PTRLIGNES:=1;
FOR I:=1 TO NOBJ-1 DO
      BEGIN
      NBLIGNES:=NBLIGNES+1;
      JM1:=I MOD MAXCOLONNES;
      JD1:=I DIV MAXCOLONNES;
      PT:=FIRST;
      FOR J:=1 TO JD1 DO PT:=PT@.LIEN;
      FOR J:=I+1 TO NOBJ DO
            BEGIN
            MULT:=ENTREEC@;GET(ENTREEC);
            IF JM1 =MAXCOLONNES THEN
                  BEGIN
                  JM1:=0;
                  JD1:=JD1+1;
                  PT:=PT@.LIEN;
                  END;
            JM1:=JM1+1;
            PT@.DATA[JM1,NBLIGNES]:=MULT.REE;
            END;
      IF ((MAXLIGNES=NBLIGNES)OR(I=NOBJ-1)) THEN
            BEGIN
            PT:=FIRST;
            II:=I;
            IF TITRE THEN COPYTITRE(PTRLIGNES,II);
            FOR J:=0 TO NBMAT-1 DO
                BEGIN
                ECRITMAT(MAXCOLONNES,NBLIGNES,J,PASSE,PT@);
                PT:=PT@.LIEN;
                END;
            IF NOBJ MOD MAXCOLONNES<>0 THEN
                BEGIN
                ECRITMAT(NOBJ MOD MAXCOLONNES,NBLIGNES,NBMAT,PASSE,PT@);
                END;
            NBLIGNES:=0;
            PASSE:=PASSE+1;
            PTRLIGNES:=I+1;
            END;
      END;
END;  (* FIN ENTREDONNEE *)

BEGIN    (* PROG PRINC *)
REWRITE(SORTIEC);
WRITELN(SORTIEC);
IF LANG=1 THEN BEGIN
WRITELN(SORTIEC,'  P R O G R A M M E   R E G A R D E ');
WRITELN(SORTIEC,'  pour examiner une matrice produite par SIMIL ');
END ELSE
WRITELN(SORTIEC,'  P R O G R A M   L O O K  to look at a SIMIL matrix');
WRITELN(SORTIEC);
WRITELN(SORTIEC,'  VERSION 3.0b');
WRITELN(SORTIEC);
ENTETE;
MEMOIRE(FIRST);
IF TITRE THEN ENTREID;
ENTREDONNEE;
IF LANG=1 THEN WRITELN(' Fin du programme.')
          ELSE WRITELN(' End of the program.');
END.
